diff -urN linux.store/linux/arch/arm/lib/traps-arm6.S linux/arch/arm/lib/traps-arm6.S
--- linux.store/linux/arch/arm/lib/traps-arm6.S	Thu Jan  1 01:00:00 1970
+++ linux/arch/arm/lib/traps-arm6.S	Fri Mar 22 22:04:08 1996
@@ -0,0 +1,1034 @@
+/*
+ * linux/arch/arm/lib/traps-arm6.S
+ *
+ * Copyright (C) 1996 Russell King.
+ *
+ * Low-level vector interface routines
+ *
+ * Design issues:
+ *  - We have several modes that each vector can be called from,
+ *    each with its own set of registers.  On entry to any vector,
+ *    we *must* save the registers used in *that* mode.
+ *
+ *  - This code must be as fast as possible.
+ *
+ * There are a few restrictions on the vectors:
+ *  - the SWI vector cannot be called from *any* non-user mode
+ *
+ *  - the FP emulator is *never* called from *any* non-user mode undefined instruction.
+ *
+ * Ok, so this file may be a mess, but its as efficient as possible while
+ * adhering to the above criteria.
+ */
+
+#include <asm/assembler.h>
+#include <asm/errno.h>
+#include <asm/hardware.h>
+
+		.text
+
+@ Offsets into task structure
+@ ---------------------------
+@
+#define STATE		0
+#define COUNTER		4
+#define PRIORITY	8
+#define SIGNAL		12
+#define BLOCKED		16
+#define FLAGS		20
+#define ERRNO		24
+
+#define PF_TRACESYS	0x20
+
+@ Bad Abort numbers
+@ -----------------
+@
+#define BAD_PREFETCH	0
+#define BAD_DATA	1
+#define BAD_ADDREXCPTN	2
+#define BAD_IRQ		3
+#define BAD_UNDEFINSTR	4
+
+@ Number of syscalls accepted
+@
+#define NSYS_CALL	142
+
+@ OS version number used in SWIs
+@  RISC OS is 0
+@  RISC iX is 8
+@
+#define OS_NUMBER	9
+
+@
+@ Stack format (ensured by USER_* and SVC_*)
+@
+#define S_FRAME_SIZE	72
+#define S_OLD_R0	68
+#define S_PSR		64
+#define S_PC		60
+#define S_LR		56
+#define S_SP		52
+#define S_IP		48
+#define S_FP		44
+#define S_R10		40
+#define S_R9		36
+#define S_R8		32
+#define S_R7		28
+#define S_R6		24
+#define S_R5		20
+#define S_R4		16
+#define S_R3		12
+#define S_R2		8
+#define S_R1		4
+#define S_R0		0
+
+#include "constants.h"
+
+#define USER_SAVE_ALL				\
+		str	r0, [sp, #-4]!		;\
+		str	lr, [sp, #-4]!		;\
+		sub	sp, sp, #15*4		;\
+		stmia	sp, {r0 - lr}^		;\
+		mov	r0, r0			;\
+		mov	fp, #0
+
+#define SVC_SAVE_ALL				\
+		str	sp, [sp, #-16]!		;\
+		str	lr, [sp, #8]		;\
+		str	lr, [sp, #4]		;\
+		stmfd	sp!, {r0 - r12}		;\
+		mov	r0, #-1			;\
+		str	r0, [sp, #S_OLD_R0]	;\
+		mov	fp, #0
+
+#define SVC_IRQ_SAVE_ALL			\
+		str	sp, [sp, #-16]!		;\
+		str	lr, [sp, #4]		;\
+		ldr	lr, [pc, #LC4 - . - 8]	;\
+		ldr	lr, [lr]		;\
+		str	lr, [sp, #8]		;\
+		stmfd	sp!, {r0 - r12}		;\
+		mov	r0, #-1			;\
+		str	r0, [sp, #S_OLD_R0]	;\
+		mov	fp, #0
+
+#define USER_RESTORE_ALL			\
+		ldmia	sp, {r0 - lr}^		;\
+		mov	r0, r0			;\
+		add	sp, sp, #15*4		;\
+		ldr	lr, [sp], #8		;\
+		bics	pc, lr, #0x0C000003	
+
+#define SVC_RESTORE_ALL				\
+		ldmfd	sp, {r0 - pc}^
+		
+		.global	_ret_from_sys_call
+
+/*
+ *================================================================================================
+ *		Low-level interface code
+ *------------------------------------------------------------------------------------------------
+ *		Trap initialisation
+ *------------------------------------------------------------------------------------------------
+ *
+ * Note - FIQ code has changed.  The default is a couple of words in 0x1c, 0x20
+ * that call _unexp_fiq.  Nowever, we now copy the FIQ routine to 0x1c (removes
+ * some excess cycles).
+ *
+ * What we need to put into 0-0x1c are ldrs to branch to 0xC0000000
+ * (the kernel).
+ * 0x1c onwards is reserved for FIQ, so I think that I will allocate 0xe0 onwards for
+ * the actuall address to jump to.
+ */
+/*
+ * these go into 0x00
+ */
+branches:	swi	SYS_ERROR0
+		ldr	pc, branches + 0xe4
+		ldr	pc, branches + 0xe8
+		ldr	pc, branches + 0xec
+		ldr	pc, branches + 0xf0
+		ldr	pc, branches + 0xf4
+		ldr	pc, branches + 0xf8
+		ldr	pc, . + 4
+		.word	_unexp_fiq
+/*
+ * this is put into 0xe0 and above
+ */
+jump_addresses:	.word	0
+		.word	vector_undefinstr
+		.word	vector_swi
+		.word	vector_prefetch
+		.word	vector_data
+		.word	vector_addrexcptn
+		.word	vector_IRQ
+/*
+ * initialise the trap system
+ */
+		.global	_trap_init
+_trap_init:	stmfd	sp !,{r4 - r9,lr}		@ Save link register
+		mrs	r0, cpsr_all
+		bic	r0, r0, #192 | 31
+		orr	r0, r0, #0xD3
+		msr	cpsr_all, r0
+		mov	r0, #IOC_BASE
+		str	r0, [r0, #0x18]
+		str	r0, [r0, #0x28]
+		str	r0, [r0, #0x38]
+		mov	r0, #0xE0
+		adr	r1, jump_addresses
+		ldmia	r1, {r1 - r7}
+		stmia	r0, {r1 - r7}
+		mov	r0, #0				@ Lowest location
+		adr	r1, branches
+		ldmia	r1,  {r1 - r9}
+		stmia	r0!, {r1 - r9}			@ Save all into page 0 ram
+		ldmfd	sp!, {r4 - r9, pc}^
+/*
+ *------------------------------------------------------------------------------------------------
+ * Undefined FIQs
+ *------------------------------------------------------------------------------------------------
+ * Enter in FIQ mode, spsr = ANY CPSR, lr = ANY PC
+ * MUST PRESERVE SVC SPSR, but need to switch to SVC mode to show our msg.
+ * Basically to switch modes, we *HAVE* to clobber one register...  brain damage alert!
+ * I don't think that we can execute any code in here in any other mode than FIQ...  Ok
+ * you can switch to another mode, but you can't get out of that mode without clobbering one
+ * register.
+ */
+_unexp_fiq:	mov	r12, #IOC_BASE
+		strb	r12, [r12, #0x38]	@ Disable FIQ register
+		subs	pc, lr, #4
+/*
+ *------------------------------------------------------------------------------------------------
+ * Interrupt entry dispatcher - dispatches it to the correct handler for the processor mode
+ *------------------------------------------------------------------------------------------------
+ * Enter in IRQ mode, spsr = SVC/USR CPSR, lr = SVC/USR PC
+ */
+LCirq:		.word	__temp_irq
+vector_IRQ:	@
+		@ save mode specific registers
+		@
+		ldr	r13, [pc, #LCirq - . - 8]
+		sub	lr, lr, #4
+		str	lr, [r13]
+		mrs	lr, spsr_all
+		str	lr, [r13, #4]
+		@
+		@ now branch to the relevent MODE handling routine
+		@
+		and	lr, lr, #15
+		cmp	lr, #4
+		addlt	pc, pc, lr, lsl #2
+		b	__irq_invalid			@ 7, 11 (ABT) (UND)
+		b	__irq_usr			@ 0  (USR)
+		b	__irq_invalid			@ 1  (FIQ)
+		b	__irq_invalid			@ 2  (IRQ)
+		b	__irq_svc			@ 3  (SVC)
+/*
+ *------------------------------------------------------------------------------------------------
+ * Undef instr entry dispatcher - dispatches it to the correct handler for the processor mode
+ *------------------------------------------------------------------------------------------------
+ * Enter in UND mode, spsr = SVC/USR CPSR, lr = SVC/USR PC
+ */
+LCund:		.word	__temp_und
+vector_undefinstr:
+		@
+		@ save mode specific registers
+		@
+		ldr	r13, [pc, #LCund - . - 8]
+		str	lr, [r13]
+		mrs	lr, spsr_all
+		str	lr, [r13, #4]
+		@
+		@ now branch to the relevent MODE handling routine
+		@
+		and	lr, lr, #15
+		cmp	lr, #4
+		addlt	pc, pc, lr, lsl #2
+		b	__und_invalid			@ 7, 11 (ABT) (UND)
+		b	__und_usr			@ 0 (USR)
+		b	__und_invalid			@ 1 (FIQ)
+		b	__und_invalid			@ 2 (IRQ)
+		b	__und_svc			@ 3 (SVC)
+/*
+ *------------------------------------------------------------------------------------------------
+ * Prefetch abort dispatcher - dispatches it to the correct handler for the processor mode
+ *------------------------------------------------------------------------------------------------
+ * Enter in ABT mode, spsr = USR CPSR, lr = USR PC
+ */
+LCabt:		.word	__temp_abt
+vector_prefetch:
+		@
+		@ save mode specific registers
+		@
+		sub	lr, lr, #4
+		ldr	r13, [pc, #LCabt - . - 8]
+		str	lr, [r13]
+		mrs	lr, spsr_all
+		str	lr, [r13, #4]
+		@
+		@ now branch to the relevent MODE handling routine
+		@
+		and	lr, lr, #31
+		teq	lr, #16
+		beq	__pabt_usr			@ 0 (USR)
+		b	__pabt_invalid			@ 1, 2, 3, 7, 11 (FIQ)(IRQ)(SVC)(ABT)(UND)
+/*
+ *------------------------------------------------------------------------------------------------
+ * Data abort dispatcher - dispatches it to the correct handler for the processor mode
+ *------------------------------------------------------------------------------------------------
+ * Enter in ABT mode, spsr = USR CPSR, lr = USR PC
+ */
+vector_data:	@
+		@ save mode specific registers
+		@
+		sub	lr, lr, #8
+		ldr	r13, [pc, #LCabt - . - 8]
+		str	lr, [r13]
+		mrs	lr, spsr_all
+		str	lr, [r13, #4]
+		@
+		@ now branch to the relevent MODE handling routine
+		@
+		and	lr, lr, #15
+		b	__dabt_invalid			@ 7, 11 (ABT) (UND)
+		b	__dabt_usr			@ 0  (USR)
+		b	__dabt_invalid			@ 1  (FIQ)
+		b	__dabt_invalid			@ 2  (IRQ)
+		b	__dabt_svc			@ 3  (SVC)
+
+/*
+ *===============================================================================
+ * SWI handler
+ *-------------------------------------------------------------------------------
+ *
+ * We now handle sys-call tracing, and the errno in the task structure.
+ * Still have a problem with >4 arguments for functions.  Theres only
+ * a couple of functions in the code that have 5 arguments, so Im not
+ * too worried.
+ */
+LC1:		.word	_current
+LC2:		.word	_sys_call_table
+/*
+ * Enter in SVC mode, spsr_all = OLD_USER_cpsr_all, R14 = OLD_USER_PC
+ */
+vector_swi:	sub	sp, sp, #S_FRAME_SIZE
+		stmia	sp, {r0 - lr}^			@ Calling r0 - lr
+		mov	r7, r0
+		mrs	r6, spsr
+		mov	r5, lr
+		add	r4, sp, #S_PC
+		stmia	r4, {r5, r6, r7}		@ Save calling PC, CPSR, OLD_R0
+		mov	fp, #0
+		ldr	r4, [lr, #-4]			@ get swi instruction
+		mrs	r5, cpsr			@ enable irqs
+		bic	r5, r5, #128
+		msr	cpsr, r5
+		bic	r4, r4, #0xff000000		@ mask off swi op code
+		eor	r4, r4, #OS_NUMBER << 20	@ check OS number
+		tst	r4, #0x00f00000
+		bne	bad
+retry:		cmp	r4, #NSYS_CALL			@ check upper syscall limit
+		bcs	swi_bad_call
+@		bl	_arm3_flushcache
+
+		ldr	r5, [pc, #LC1 - . - 8]
+		ldr	r5, [r5]
+		mov	ip, #0				@ zero errno
+		str	ip, [r5, #ERRNO]
+
+		ldr	ip, [r5, #FLAGS]		@ check for syscall tracing
+		tst	ip, #PF_TRACESYS
+		bne	trace_this_syscall
+
+		ldr	ip, [pc, #LC2 - . - 8]
+		mov	r9, sp				@ hack for routines needing > 4 values
+		mov	lr, pc
+		ldr	pc, [ip, r4, lsl #2]		@ call sys routine
+
+		ldr	ip, [r5, #ERRNO]		@ check errno
+		rsbs	ip, ip, #0
+		movne	r0, ip
+		streq	r0, [sp, #0]			@ returned r0
+@		bl	_arm3_flushcache
+		b	_ret_from_sys_call
+
+trace_this_syscall:
+		ldr	r7, [sp, #S_IP]
+		mov	r0, #0
+		str	r0, [sp, #S_IP]
+		bl	_syscall_trace			@ trace entry [IP must = 0]
+		str	r7, [sp, #S_IP]
+		ldmia	sp, {r0 - r3}			@ have to reload r0 - r3
+
+		ldr	ip, [pc, #LC2 - . - 8]
+		mov	r9, sp				@ hack for routines needing > 4 values
+		mov	lr, pc
+		ldr	pc, [ip, r4, lsl #2]		@ call sys routine
+
+		ldr	ip, [r5, #ERRNO]
+		rsbs	ip, ip, #0
+		movne	r0, ip
+		str	r0, [sp, #0]			@ returned r0
+
+		mov	r0, #1
+		str	r0, [sp, #S_IP]
+		bl	_syscall_trace			@ trace exit [IP must != 0]
+		str	r7, [sp, #S_IP]
+@		bl	_arm3_flushcache
+		b	_ret_from_sys_call
+
+
+swi_bad_call:	cmp	r4, #(KSWI_SYS_BASE - KSWI_BASE)@ check for arm private syscalls
+		bcs	arm_sys_call
+		bl	_sys_ni_syscall
+		str	r0, [sp, #0]			@ returned r0
+		b	_ret_from_sys_call
+
+bad:		bl	_deferred
+		ldmfd	sp, {r0 - r3}
+		b	retry
+
+arm_sys_call:	bic	r0, r4, #0x000f0000
+		mov	r1, sp
+		bl	_arm_syscall
+		b	_ret_from_sys_call
+/*
+ *================================================================================================
+ * Undefined instruction handler
+ *------------------------------------------------------------------------------------------------
+ */
+LC9:		.word	_fp_enter
+		.word	_fp_save
+		.word	_fp_restore
+
+__und_usr:	mrs	lr, cpsr			@ Change to SVC mode
+		bic	lr, lr, #31
+		orr	lr, lr, #0x13
+		msr	cpsr, lr
+		mov	r0, r0
+		sub	sp, sp, #S_FRAME_SIZE		@ Allocate frame size in one go
+		stmia	sp, {r0 - lr}^			@ Save USR r0 - lr
+		mov	r7, r0				@ OLD R0
+		ldr	r4, [pc, #LCund - . - 8]
+		ldmia	r4, {r5, r6}			@ Get USR pc, cpsr
+		add	r4, sp, #S_PC
+		stmia	r4, {r5, r6, r7}		@ Save USR pc, cpsr, old_r0
+		@
+		@ Call FP module
+		@
+		ldr	r3, [pc, #LC9 - . - 8]
+		ldr	pc, [r3]			@ Call FP module (when loaded)
+
+		.global	_fpreturn
+		.global	_fpundefinstr
+_fpundefinstr:	mov	r0, lr				@ Called by FP module on undefined instr
+		mov	r1, sp
+		mov	r2, #0
+		mrs	r4, cpsr			@ Enable interrupts
+		bic	r4, r4, #128
+		msr	cpsr, r4
+		bl	_do_undefinstr
+_fpreturn:	b	_ret_from_sys_call		@ Normal FP exit
+
+/*
+ * Function to call when switching tasks to save FP state
+ */
+		.global	_fpe_save
+_fpe_save:	ldr	r1, [pc, #LC9 - . - 4]
+		ldr	pc, [r1]
+
+/*
+ * Function to call when switching tasks to restore FP state
+ */
+		.global	_fpe_restore
+_fpe_restore:	ldr	r1, [pc, #LC9 - . - 0]
+		ldr	pc, [r1]
+
+__und_svc:	mrs	lr, cpsr
+		bic	lr, lr, #31
+		orr	lr, lr, #0x13
+		msr	cpsr, lr
+		mov	r0, r0
+		sub	sp, sp, #S_FRAME_SIZE
+		stmia	sp, {r0 - lr}			@ Save SVC r0 - lr [lr *should* be intact]
+		mov	r7, r0
+		ldr	r4, [pc, #LCund - . - 8]
+		ldmia	r4, {r5, r6}			@ Get SVC pc, cpsr
+		add	r4, sp, #S_PC
+		stmia	r4, {r5, r6, r7}		@ Save SVC pc, cpsr, old_r0
+		mov	r0, r5				@ unsigned long pc
+		mov	r1, sp				@ struct pt_regs *regs
+		and	r2, r6, #31			@ mode
+		bl	_do_undefinstr
+		ldr	lr, [sp, #S_PSR]		@ Get SVC cpsr
+		msr	spsr, lr
+		ldmia	sp, {r0 - pc}^			@ Restore SVC registers
+
+__und_invalid:	mrs	lr, cpsr
+		bic	lr, lr, #31
+		orr	lr, lr, #0x13
+		msr	cpsr, lr
+		mov	r0, r0
+		sub	sp, sp, #S_FRAME_SIZE
+		stmia	sp, {r0 - lr}
+		mov	r7, r0
+		ldr	r4, [pc, #LCund - . - 8]
+		ldmia	r4, {r5, r6}			@ Get UND/IRQ/FIQ/ABT pc, cpsr
+		add	r4, sp, #S_PC
+		stmia	r4, {r5, r6, r7}		@ Save UND/IRQ/FIQ/ABT pc, cpsr, old_r0
+		mov	r0, sp				@ struct pt_regs *regs
+		mov	r1, #BAD_UNDEFINSTR		@ int reason
+		and	r2, r6, #31			@ int mode
+		b	_bad_mode			@ Does not ever return...
+/*
+ *================================================================================================
+ * Prefetch abort handler
+ *------------------------------------------------------------------------------------------------
+ */
+__pabt_usr:	mrs	lr, cpsr			@ Change to SVC mode
+		bic	lr, lr, #31
+		orr	lr, lr, #0x13
+		msr	cpsr, lr
+		mov	r0, r0
+		sub	sp, sp, #S_FRAME_SIZE		@ Allocate frame size in one go
+		stmia	sp, {r0 - lr}^			@ Save USR r0 - lr
+		mov	r7, r0				@ OLD R0
+		ldr	r4, [pc, #LCabt - . - 8]
+		ldmia	r4, {r5, r6}			@ Get USR pc, cpsr
+		add	r4, sp, #S_PC
+		stmia	r4, {r5, r6, r7}		@ Save USR pc, cpsr, old_r0
+		tst	r6, #128
+		mrseq	r7, cpsr			@ Enable interrupts if they were
+		biceq	r7, r7, #128			@ previously
+		msreq	cpsr, r7
+		mov	r0, r5				@ unsigned long min_addr
+		add	r1, r0, #4			@ unsigned long max_addr
+		mov	r2, #0x100			@ int error_code
+		mov	r3, sp				@ struct pt_regs *regs
+		bl	_do_dataabort			@ call abort handler
+		teq	r0, #0
+		bne	_ret_from_sys_call		@ Return from sys call
+#ifdef DEBUG_UNDEF
+		adr	r0, t
+		bl	_printk
+#endif
+		mov	r0, r5
+		mov	r1, sp
+		and	r2, r6, #31
+		bl	_do_undefinstr
+		ldr	lr, [sp, #S_PSR]		@ Get SVC cpsr
+		msr	spsr, lr
+		ldmia	sp, {r0 - pc}^			@ Restore SVC registers
+
+__pabt_invalid:	mrs	lr, cpsr			@ Change to SVC mode
+		bic	lr, lr, #31
+		orr	lr, lr, #0x13
+		msr	cpsr, lr
+		mov	r0, r0
+		sub	sp, sp, #S_FRAME_SIZE		@ Allocate frame size in one go
+		stmia	sp, {r0 - lr}			@ Save XXX r0 - lr
+		mov	r7, r0				@ OLD R0
+		ldr	r4, [pc, #LCabt - . - 8]
+		ldmia	r4, {r5, r6}			@ Get XXX pc, cpsr
+		add	r4, sp, #S_PC
+		stmia	r4, {r5, r6, r7}		@ Save XXX pc, cpsr, old_r0
+		mov	r0, sp				@ Prefetch aborts are definitely *not*
+		mov	r1, #BAD_PREFETCH		@ allowed in non-user modes.  We cant
+		and	r2, r6, #31			@ recover from this problem.
+		b	_bad_mode
+
+#ifdef DEBUG_UNDEF
+t:	.ascii "*** undef ***\r\n\0"
+	.align
+#endif
+/*
+ *================================================================================================
+ * Address exception handler
+ *------------------------------------------------------------------------------------------------
+ * These aren't too critical. (they're not supposed to happen, and won't happen in 32-bit mode).
+ */
+
+vector_addrexcptn:
+		b	vector_addrexcptn
+#if 0
+		sub	lr, lr, #8
+		tst	lr, #3
+		bne	addrexcptn_not_user
+		USER_SAVE_ALL
+		teq	pc, #0x00000003
+		bic	r0, lr, #0xfc000003		@ Point to instruction
+		mov	r1, sp				@ Point to registers
+		mov	r2, #0x400
+		bl	_do_excpt
+		b	_ret_from_sys_call
+
+addrexcptn_not_user:
+		SVC_SAVE_ALL
+		and	r2, lr, #3
+		teq	r2, #3
+		bne	addrexcptn_illegal_mode
+		teqp	pc, #0x00000003			@ NOT a problem - doesnt change mode
+		bic	r0, lr, #0xfc000003
+		mov	r1, sp
+		orr	r2, r2, #0x400
+		bl	_do_excpt
+		ldmia	sp, {r0 - lr}			@ I cant remember the reason I changed this...
+		add	sp, sp, #15*4
+		movs	pc, lr
+
+addrexcptn_illegal_mode:
+		mov	r0, sp
+		str	lr, [sp, #-4]!
+		orr	r1, r2, #0x0c000000
+		teqp	r1, #0				@ change into mode (wont be user mode)
+		mov	r0, r0
+		mov	r1, r8				@ Any register from r8 - r14 can be banked
+		mov	r2, r9
+		mov	r3, r10
+		mov	r4, r11
+		mov	r5, r12
+		mov	r6, r13
+		mov	r7, r14
+		teqp	pc, #0x04000003			@ back to svc
+		mov	r0, r0
+		stmfd	sp!, {r1-r7}
+		ldmia	r0, {r0-r7}
+		stmfd	sp!, {r0-r7}
+		mov	r0, sp
+		mov	r1, #BAD_ADDREXCPTN
+		b	_bad_mode
+#endif
+/*
+ *================================================================================================
+ * Interrupt (IRQ) handler (r13 points to irq temp save area)
+ * MOD: if in user mode, then *no* kernel routine is running, so dont have to
+ *      save svc lr
+ *------------------------------------------------------------------------------------------------
+ */
+LC5:		.word	_irqjump
+__irq_usr:	mrs	lr, cpsr			@ switch to SVC mode
+		bic	lr, lr, #31
+		orr	lr, lr, #0x13
+		msr	cpsr, lr
+		mov	r0, r0
+		sub	sp, sp, #S_FRAME_SIZE
+		stmia	sp, {r0 - lr}^			@ save r0 - lr
+		mov	r7, r0
+		ldr	r4, [pc, #LCirq - . - 8]
+		ldmia	r4, {r5, r6}			@ get saved PC, SPSR
+		add	r4, sp, #S_PC
+		stmia	r4, {r5, r6, r7}		@ save pc, psr, old_r0
+urepeat:	mov	r4, #IOC_BASE			@ point at IOC
+		ldrb	r1, [r4, #0x24]			@ get high priority first
+		adr	r2, irq_prio_h
+		teq	r1, #0
+		ldreqb	r1, [r4, #0x14]			@ get low priority
+		adreq	r2, irq_prio_l
+		teq	r1, #0
+		beq	_ret_from_sys_call
+		ldrb	r0, [r2, r1]			@ Get IRQ number
+		ldr	r2, [pc, #LC5 - . - 8]
+		mov	r1, sp
+		mov	lr, pc
+		@
+		@ routine gets called with r0 = interrupt number, r1 = struct pt_regs *
+		@
+		ldr	pc, [r2, r0, lsl#2]
+		mov	r2, #0
+		teq	r0, #0				@ Check to see if it is a fast IRQ
+		beq	_ret_from_sys_call
+		ldr	fp, [sp, #S_PSR]		@ Get saved SPSR
+		bic	fp, fp, #192 | 15
+		orr	fp, fp, #16			@ Force USER mode, IRQs+FIQs on
+		msr	spsr, fp			@ restore SPSR
+		ldmia	sp, {r0 - lr}^			@ Get calling r0 - lr
+		mov	r0, r0
+		add	sp, sp, #S_PC
+		ldr	lr, [sp], #12
+		movs	pc, lr
+
+LC65:
+		.word	_intr_count			@ -8
+		.word	_bh_mask			@ -4
+		.word	_bh_active			@ -0
+
+__irq_svc:	mrs	lr, cpsr			@ switch to SVC mode
+		bic	lr, lr, #31
+		orr	lr, lr, #0x13
+		msr	cpsr, lr
+		mov	r0, r0
+		sub	sp, sp, #S_FRAME_SIZE
+		stmia	sp, {r0 - lr}			@ save SVC r0 - lr
+		mov	r7, #-1
+		ldr	r4, [pc, #LCirq - . - 8]
+		ldmia	r4, {r5, r6}			@ saved pc, psr
+		add	r4, sp, #S_PC
+		stmia	r4, {r5, r6, r7}		@ save SVC PC, PSR, old_r0
+		mov	fp, #0
+srepeat:	mov	r4, #IOC_BASE		@ point at IOC
+		ldrb	r1, [r4, #0x24]		@ get high priority first
+		adr	r2, irq_prio_h
+		teq	r1, #0
+		ldreqb	r1, [r4, #0x14]		@ get low priority
+		adreq	r2, irq_prio_l
+		teq	r1, #0
+		beq	no_irq2
+		ldrb	r0, [r2, r1]		@ Get IRQ number
+		ldr	r2, [pc, #LC5 - . - 8]
+		mov	r1, sp
+		mov	lr, pc
+		@
+		@ routine gets called with r0 = interrupt number, r1 = struct pt_regs *
+		@
+		ldr	pc, [r2, r0, lsl#2]
+		mov	r2, #1
+		teq	r0, #0			@ Check to see if it is a fast IRQ
+		bne	srepeat
+		ldr	r0, [pc, #LC65 - . - 8]
+		ldr	r1, [r0]
+		teq	r1, #0
+		bne	srepeat
+		mov	r4, r0
+		mov	r5, r1
+		ldr	r6, [pc, #LC65 - . - 4]
+		ldr	r7, [pc, #LC65 - . - 0]
+recheck_bh2:	ldr	r0, [r6]
+		ldr	r1, [r7]
+		tst	r0, r1
+		beq	srepeat
+		add	r0, r5, #1
+		str	r0, [r4]
+		mov	r8, pc
+		teqp	pc, #0x00000003
+		bl	_do_bottom_half
+		teqp	r8, #0
+		str	r5, [r4]
+		b	recheck_bh2
+no_irq2:	ldr	r0, [sp, #S_PSR]
+		msr	spsr, r0
+		ldmfd	sp, {r0 - pc}^
+
+__irq_invalid:	mrs	lr, cpsr		@ switch to svc mode
+		bic	lr, lr, #31
+		orr	lr, lr, #0x13
+		msr	cpsr, lr
+		mov	r0, r0
+		sub	sp, sp, #S_FRAME_SIZE	@ Allocate space on stack for frame
+		stmfd	sp, {r0 - lr}		@ Save r0 - lr
+		mov	r7, #-1
+		ldr	r4, [pc, #LCirq - . - 8]
+		ldmia	r4, {r5, r6}		@ get saved pc, psr
+		add	r4, sp, #S_PC
+		stmia	r4, {r5, r6, r7}
+		mov	fp, #0
+		mov	r0, sp
+		mov	r1, #BAD_IRQ
+		b	_bad_mode
+/*
+ *================================================================================================
+ * Data abort handler code
+ *------------------------------------------------------------------------------------------------
+ * This needs some work ...
+ */
+__dabt_usr:	mrs	lr, cpsr			@ Change to SVC mode
+		bic	lr, lr, #31
+		orr	lr, lr, #0x13
+		msr	cpsr, lr
+		mov	r0, r0
+		sub	sp, sp, #S_FRAME_SIZE		@ Allocate frame size in one go
+		stmia	sp, {r0 - lr}^			@ Save USR r0 - lr
+		mov	r7, r0				@ OLD R0
+		ldr	r4, [pc, #LCabt - . - 8]
+		ldmia	r4, {r5, r6}			@ Get USR pc, cpsr
+		add	r4, sp, #S_PC
+		stmia	r4, {r5, r6, r7}		@ Save USR pc, cpsr, old_r0
+		tst	r6, #128
+		mrseq	r7, cpsr			@ Enable interrupts if they were
+		biceq	r7, r7, #128			@ previously
+		msreq	cpsr, r7
+
+__dabt_svc:	mrs	lr, cpsr
+		bic	lr, lr, #31
+		orr	lr, lr, #0x13
+		msr	cpsr, lr
+		mov	r0, r0
+		sub	sp, sp, #S_FRAME_SIZE
+		stmia	sp, {r0 - lr}			@ Save SVC r0 - lr [lr *should* be intact]
+		mov	r7, r0
+		ldr	r4, [pc, #LCabt - . - 8]
+		ldmia	r4, {r5, r6}			@ Get SVC pc, cpsr
+		add	r4, sp, #S_PC
+		stmia	r4, {r5, r6, r7}		@ Save SVC pc, cpsr, old_r0
+		tst	r6, #128
+		mrseq	r7, cpsr			@ Enable interrupts if they were
+		biceq	r7, r7, #128			@ previously
+		msreq	cpsr, r7
+
+__dabt_invalid:	mrs	lr, cpsr
+		bic	lr, lr, #31
+		orr	lr, lr, #0x13
+		msr	cpsr, lr
+		mov	r0, r0
+		sub	sp, sp, #S_FRAME_SIZE
+		stmia	sp, {r0 - lr}			@ Save SVC r0 - lr [lr *should* be intact]
+		mov	r7, r0
+		ldr	r4, [pc, #LCabt - . - 8]
+		ldmia	r4, {r5, r6}			@ Get SVC pc, cpsr
+		add	r4, sp, #S_PC
+		stmia	r4, {r5, r6, r7}		@ Save SVC pc, cpsr, old_r0
+		mov	r0, sp
+		mov	r1, #BAD_DATA
+		and	r2, r6, #31
+		b	_bad_mode
+#if 0
+vector_data:	b	vector_data
+		sub	lr, lr, #8		@ Correct lr
+		tst	lr, #3
+		bne	data_not_user
+		USER_SAVE_ALL
+		tst	lr, #0x08000000
+		teqeqp	pc, #0x00000003		@ NOT a problem - doesnt change mode
+		bic	r0, lr, #0xFC000003
+		mov	r2, #0
+		mov	r3, sp
+		bl	data_do
+		b	_ret_from_sys_call
+
+data_not_user:	
+		SVC_SAVE_ALL
+		and	r2,lr,#3
+		teq	r2,#3
+		bne	data_illegal_mode
+		tst	lr,#0x08000000
+		teqeqp	pc,#0x00000003		@ NOT a problem - doesnt change mode
+		bic	r0,lr,#0xFC000003
+		mov	r3,sp
+		bl	data_do
+		SVC_RESTORE_ALL
+#endif
+/*
+ * Interrupt table (incorporates priority)
+ */
+irq_prio_l:	.byte	 0, 0, 1, 0, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3
+		.byte	 4, 0, 1, 0, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3
+		.byte	 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5
+		.byte	 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5
+		.byte	 6, 6, 6, 6, 6, 6, 6, 6, 3, 3, 3, 3, 3, 3, 3, 3
+		.byte	 6, 6, 6, 6, 6, 6, 6, 6, 3, 3, 3, 3, 3, 3, 3, 3
+		.byte	 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5
+		.byte	 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5
+		.byte	 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7
+		.byte	 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7
+		.byte	 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7
+		.byte	 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7
+		.byte	 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7
+		.byte	 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7
+		.byte	 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7
+		.byte	 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7
+irq_prio_h:	.byte	 0, 8, 9, 8,10,10,10,10,11,11,11,11,10,10,10,10
+		.byte	12, 8, 9, 8,10,10,10,10,11,11,11,11,10,10,10,10
+		.byte	13,13,13,13,10,10,10,10,11,11,11,11,10,10,10,10
+		.byte	13,13,13,13,10,10,10,10,11,11,11,11,10,10,10,10
+		.byte	14,14,14,14,10,10,10,10,11,11,11,11,10,10,10,10
+		.byte	14,14,14,14,10,10,10,10,11,11,11,11,10,10,10,10
+		.byte	13,13,13,13,10,10,10,10,11,11,11,11,10,10,10,10
+		.byte	13,13,13,13,10,10,10,10,11,11,11,11,10,10,10,10
+		.byte	15,15,15,15,10,10,10,10,11,11,11,11,10,10,10,10
+		.byte	15,15,15,15,10,10,10,10,11,11,11,11,10,10,10,10
+		.byte	13,13,13,13,10,10,10,10,11,11,11,11,10,10,10,10
+		.byte	13,13,13,13,10,10,10,10,11,11,11,11,10,10,10,10
+		.byte	15,15,15,15,10,10,10,10,11,11,11,11,10,10,10,10
+		.byte	15,15,15,15,10,10,10,10,11,11,11,11,10,10,10,10
+		.byte	13,13,13,13,10,10,10,10,11,11,11,11,10,10,10,10
+		.byte	13,13,13,13,10,10,10,10,11,11,11,11,10,10,10,10
+#if 0
+@ ----------------------------------------------------------------------------------------------
+@
+@ This is where I wish that the ARM would tell you which address aborted.
+@
+
+data_do:	ldr	r5, [r0]		@ Get instruction
+		tst	r5, #1<<20		@ Check to see if it is a write instruction
+		orreq	r2, r2, #0x20		@ Indicate write instruction
+		tst	r5, #1 << 26		@ Check LDMSTM/LDRSTRLDCSTC
+		bne	data_ldrstrldcstc	@ If set, then it is not LDMSTM
+
+		mov	r6, #1 << 15
+		mov	r7, #0
+data_ldmstm_cr:	tst	r5, r6			@ Check this register
+		addne	r7, r7, #4		@ If set, then another register
+		movs	r6, r6, lsr#1
+		bne	data_ldmstm_cr
+		eor	r1, r5, r5, lsl#2
+		tst	r1, #1<<23		@ Check inc/dec bit ^ writeback
+		rsbeq	r7, r7, #0
+		mov	r4, r5, lsr#(16-2)	@ Get base register
+		and	r4, r4, #15*4		@ Mask out register
+		ldr	r0, [r3, r4]		@ Get reg
+		add	r7, r0, r7		@ Do correction (signed)
+		moveq	r1, r0
+		moveq	r0, r7
+		movne	r1, r7
+		tst	r5, #1<<21
+		strne	r7, [r3, r4]
+		teq	r4, #15*4		@ CHECK FOR PC
+		biceq	r1, r1, #0xfc000003
+		biceq	r0, r0, #0xfc000003
+		orr	r2, r2, #0x200
+		b	_do_dataabort
+
+data_ldrstrldcstc:
+		mov	r6, r5, lsr#(16-2)	@ Get Rn
+		and	r6, r6, #15*4		@ Mask out register
+		teq	r6, #15*4		@ CHECK FOR PC
+		ldr	r6, [r3, r6]		@ Get register
+		biceq	r6, r6, #0xfc000003
+		tst	r5, #1 << 24		@ Check index type bit
+		beq	ldrstrpost		@ Post indexing?
+		tst	r5, #1 << 27		@ Get LDRSTR/LDCSTC bit
+		bne	instrldcstc		@ If set, do LDC/STC instruction
+		tst	r5, #1 << 25		@ Check immediate bit
+		bne	ldrstrregval		@ Register is specified
+		mov	r1, #0xff
+		orr	r1, r1, #0xf00
+		and	r7, r5, r1
+ldrstrsubadd:
+		tst	r5, #1 << 23
+		addne	r1, r6, r7
+		movne	r0, r6
+		moveq	r1, r6			@ Set higher address same
+		subeq	r0, r6, r7		@ Apply correction
+		orr	r2, r2, #0x300
+		b	_do_dataabort
+
+ldrstrpost:	mov	r0, r6
+		mov	r1, r0			@ Set higher address same
+		tst	r5, #1 << 21
+		bicne	r2, r2, #3		@ If T bit is set, force user mode
+		orr	r2, r2, #0x400
+		b	_do_dataabort
+
+ldrstrregval:	and	r7, r5,#15
+		teq	r7, #15			@ CHECK FOR PC
+		ldr	r7, [r3, r7, lsl#2]	@ Get Rm
+		biceq	r7, r7, #0xfc000003
+		and	r8, r5, #0x60		@ Get shift types
+		mov	r9, r5, lsr#7
+		and	r9, r9, #31		@ Get shift amount
+		teq	r8, #0			@ LSL shift
+		moveq	r7, r7, lsl r9
+		teq	r8, #0x20		@ LSR shift
+		moveq	r7, r7, lsr r9
+		teq	r8, #0x40		@ ASR shift
+		moveq	r7, r7, asr r9
+		teq	r8, #0x60		@ ROR shift
+		moveq	r7, r7, ror r9
+		tst	r5, #1 << 23
+		addne	r0, r6, r7
+		subeq	r0, r6, r7		@ Apply correction
+		mov	r1, r0
+		orr	r2, r2, #0x500
+		b	_do_dataabort
+
+instrldcstc:	and	r7, r5, #255		@ Get offset
+		orr	r2, r2, #0x600
+		B	ldrstrsubadd
+#endif
+/*
+ *================================================================================================
+ * All exits to user mode from the kernel go through this code.
+ */
+
+LC6:
+		.word	_intr_count		@ -8
+		.word	_bh_mask		@ -4
+		.word	_bh_active		@ -0
+		.word	_need_resched		@ +4
+		.word	_current		@ +8
+		.word	_init_task		@ +12
+
+reschedule:	bl	_schedule
+
+_ret_from_sys_call:
+		ldr	r4, [pc, #LC6 - . - 8]
+		ldr	r5, [r4]
+		teq	r5, #0
+		bne	ret_no_check
+		ldr	r6, [pc, #LC6 - . - 4]
+		ldr	r7, [pc, #LC6 - . - 0]
+recheck_bh:	ldr	r0, [r6]
+		ldr	r1, [r7]
+		tst	r0, r1
+		beq	no_handle_bh
+handle_bottom_half:
+		add	r0, r5, #1
+		str	r0, [r4]
+		mov	r8, pc
+		mrs	lr, cpsr_all
+		bic	lr, lr, #128
+		msr	cpsr_all, lr
+		bl	_do_bottom_half
+		teqp	r8, #0
+		str	r5, [r4]
+		b	recheck_bh
+no_handle_bh:	mrs	lr, cpsr_all
+		bic	lr, lr, #128
+		msr	cpsr_all, lr
+		ldr	r0, [pc, #LC6 - . + 4]
+		ldr	r0, [r0]
+		teq	r0, #0
+		bne	reschedule
+		ldr	r4, [pc, #LC6 - . + 8]
+		ldr	r4, [r4]
+		ldr	r0, [pc, #LC6 - . + 12]
+		teq	r4, r0
+		beq	ret_no_check
+		ldr	r0, [r4, #STATE]
+		teq	r0, #0
+		bne	reschedule
+		ldr	r0, [r4, #COUNTER]
+		teq	r0, #0
+		beq	reschedule
+		ldr	r1, [r4, #SIGNAL]
+		ldr	r0, [r4, #BLOCKED]
+		bics	r1, r1, r0
+		movne	r1, sp
+		blne	_do_signal
+ret_no_check:	mrs	lr, cpsr_all			@ disable IRQs
+		orr	lr, lr, #128
+		msr	cpsr_all, lr
+		ldr	fp, [sp, #S_PSR]		@ Get calling cpsr
+		bic	fp, fp, #192 | 15
+		orr	fp, fp, #16			@ Force USER mode, IRQs+FIQs on
+		msr	spsr_all, fp
+		ldmia	sp, {r0 - lr}^			@ Get calling r0 - lr
+		mov	r0, r0
+		add	sp, sp, #S_PC
+		ldr	lr, [sp], #12			@ Get PC and jump over PC, PSR, OLD_R0
+		movs	pc, lr
+
+_arm3_flushcache:
+		mcr	15, 0, r0, c1, c0		@ flush cache
+		movs	pc, lr
+
+_fpnull:	mov	pc, lr
+
+		.data
+
+		.global	_fp_enter
+		.global	_fp_save
+		.global	_fp_restore
+
+_fp_enter:	.word	_fpundefinstr
+_fp_save:	.word	_fpnull
+_fp_restore:	.word	_fpnull
+
+_temp_irq:	.word	0				@ saved lr_irq
+		.word	0				@ saved spsr_irq
+
+_temp_und:	.word	0				@ Saved lr_und
+		.word	0				@ Saved spsr_und
+
+_temp_abt:	.word	0				@ Saved lr_abt
+		.word	0				@ Saved spsr_abt
